import ij.IJ;
import ij.gui.GUI;
import ij.plugin.frame.PlugInFrame;
import java.awt.Button;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class TJ_Panel extends PlugInFrame implements ActionListener {

    Panel panel;
    Button affine,crop,embed,mirror,rotate,scale,shift,turn,empty,about,options,website;

    public TJ_Panel() {

	super(TJ.name());
	setLayout(new FlowLayout());
	panel = new Panel();
	panel.setLayout(new GridLayout(4,3,5,5));
	affine = addButton("Affine");
	crop = addButton("Crop");
	embed = addButton("Embed");
	mirror = addButton("Mirror");
	rotate = addButton("Rotate");
	scale = addButton("Scale");
	shift = addButton("Shift");
	turn = addButton("Turn");
	empty = addButton("Empty"); empty.setEnabled(false);
	about = addButton("About");
	options = addButton("Options");
	website = addButton("Website");
	add(panel);
	pack();
	GUI.center(this);
	setVisible(true);

	TJ.debug(TJ.name()+" "+TJ.version()+": Panel");
    }

    Button addButton(String label) {

	final Button b = new Button("   "+label+"   ");
	b.addActionListener(this);
	panel.add(b);
	return b;
    }

    public void actionPerformed(ActionEvent e) {

	if (e.getSource() == affine) { IJ.doCommand("TJ Affine"); }
	else if (e.getSource() == crop) { IJ.doCommand("TJ Crop"); }
	else if (e.getSource() == embed) { IJ.doCommand("TJ Embed"); }
	else if (e.getSource() == mirror) { IJ.doCommand("TJ Mirror"); }
	else if (e.getSource() == rotate) { IJ.doCommand("TJ Rotate"); }
	else if (e.getSource() == scale) { IJ.doCommand("TJ Scale"); }
	else if (e.getSource() == shift) { IJ.doCommand("TJ Shift"); }
	else if (e.getSource() == turn) { IJ.doCommand("TJ Turn"); }
	else if (e.getSource() == about) { IJ.doCommand("TJ About"); }
	else if (e.getSource() == options) { IJ.doCommand("TJ Options"); }
	else if (e.getSource() == website) { IJ.doCommand("TJ Website"); }
    }

}
